#============================================================================================================================================#
# -*- coding:Utf-8 -*-
# sound_menu V1.0p (27/12/2007)
# MATTIE'S EVENTSCRIPTS 2.0, PYTHON OPERATIONNEL




import psyco
psyco.full()

import es, os, re, popuplib, playerlib, ConfigParser
from es import server_var
from FileAnalyse import FileAnalyse




#    Info    #
sm_info = es.AddonInfo()
sm_info.version = "1.0p"
sm_info.author = "DoCky"
sm_info.name = "sound_menu"
sm_info.url = "http://addons.eventscripts.com/addons/user/11751"
sm_path = os.getcwd().replace(os.sep, "/") + "/cstrike/cfg/sound_menu/"




#    Class    #
class SoundMenu:
    """
        Classe privé

            -créer une base de données avec les fichiers de configurations
            -créer un menu correspondant aux éléments de la base de données 
    """


    def slMake(self, cfgFile):
        """
            Fonction: créer une liste de touts les fichiers de type "CFG"
        """

        sm_patt = re.compile(".*\.cfg$").search
        sm_file = filter(sm_patt, cfgFile)

        for sm_type in sm_file:
            sm_file[sm_file.index(sm_type)] = os.path.splitext(sm_type)[0]

        self.__setConf(sm_file)


    def smMake(self):
        """
            Fonction: créer les pages du menu selon les fichiers crées
        """

        self.__sm_down = []
        self.__sm_conf = ConfigParser.ConfigParser()
        self.__sm_pars = ConfigParser.ConfigParser()

        self.slMake(os.listdir(sm_path + "sound"))

        sm_list = self.getConf().sections()
        sm_list.sort()

        for sm_type in sm_list:
            sm_sons = self.getConf().options(sm_type)
            sm_sons.sort()
            self.__sons(sm_list, sm_type, sm_sons)

        self.__type(sm_list)
        self.__menu(sm_list)
        self.__team(sm_list)


    def __setConf(self, cfgFile):
        """
            Fonction: analyse et enregistrement des informations dans une base de données
        """

        for sm_file in cfgFile:
            sm_read = FileAnalyse(sm_path + "sound/" + sm_file + ".cfg").getList()

            if sm_read:
                self.__sm_conf.add_section(str(sm_file))

                for sm_conf in sm_read:
                    sm_spli = sm_conf.split("=")
                    self.__sm_down.append("sound/" + str(sm_spli[1].strip()))
                    self.__sm_conf.set(str(sm_file), str(sm_spli[0].strip()), str(sm_spli[1].strip()))


    def __page(self, itemCount):
        """
            Fonction: déterminer le nombre de pages
        """

        if itemCount < 9:
            return 1

        else:
            sm_page = itemCount / 7
            sm_rest = itemCount % 7

            if sm_rest > 1:
                sm_page += 1

            return sm_page


    def __item(self, itemIndex, itemPages, itemCount):
        """
            Fonction: déterminer le nombre de choix
        """

        if itemIndex + 1 < itemPages:
            return 7

        else:
            return itemCount - ((itemIndex) * 7)


    def __menu(self, typeList):
        """
            Fonction: créer les pages du menu d'acceuil
        """

        sm_menu = popuplib.create("sm_menu")
        sm_menu.addline("Sound menu")
        sm_menu.addline("->1. Liste des sons")
        sm_menu.addline("->2. Liste des joueurs")
        sm_menu.addline("->3. Liste des équipes")
        sm_menu.addline("->4. Stopper les sons")
        sm_menu.addline("0. Exit")

        if len(typeList) > 1:
            sm_menu.submenu(1, "sm_type_0")

        else:
            sm_menu.submenu(1, "sm_type_%s_0" % str(typeList[0]))

        sm_menu.submenu(3, "sm_team")

        if bool(SoundInfo.sm_stic):
            sm_menu.submenu(4, "sm_menu")

        sm_menu.menuselect = menu


    def __type(self, typeList):
        """
            Fonction: créer les pages du menu selon les types répertoriés
        """

        sm_page = self.__page(len(typeList))
        sm_indp = 0

        while sm_indp < sm_page:
            sm_indi = 0
            sm_name = "sm_type_%s" % str(sm_indp)
            sm_item = self.__item(sm_indp, sm_page, len(typeList))

            sm_crea = popuplib.create(sm_name)
            sm_crea.addline("Choisir type :    %s/%s" % (str(sm_indp + 1), str(sm_page)))

            while sm_indi < sm_item:
                sm_indi += 1
                sm_crea.addline("->%s. %s" % (str(sm_indi), str(typeList[(sm_indp * 7) + (sm_indi - 1)])))
                sm_crea.submenu(sm_indi, "sm_type_%s_0" % str(typeList[(sm_indp * 7) + (sm_indi - 1)]))

            if sm_indp + 1 < sm_page:
                sm_crea.addline("8. Next")
                sm_crea.submenu(8, "sm_type_%s" % (str(sm_indp + 1)))

            if sm_indp == 0:
                sm_crea.addline("9. Menu")
                sm_crea.submenu(9, "sm_menu")

            else:
                sm_crea.addline("9. Back")
                sm_crea.submenu(9, "sm_type_%s" % (str(sm_indp - 1)))

            sm_crea.addline("0. Exit")
            sm_indp += 1


    def __sons(self, typeList, sonsType, sonsList):
        """
            Fonction: créer les pages du menu selon les sons répertoriés
        """

        sm_page = self.__page(len(sonsList))
        sm_indp = 0

        while sm_indp < sm_page:
            sm_indi = 0
            sm_item = self.__item(sm_indp, sm_page, len(sonsList))
            sm_name = "sm_type_%s_%s" % (str(sonsType), str(sm_indp))

            self.__sm_pars.add_section(sm_name)
            sm_crea = popuplib.create(sm_name)
            sm_crea.addline("%s :    %s/%s" % (str(sonsType), str(sm_indp + 1), str(sm_page)))

            while sm_indi < sm_item:
                sm_indi += 1
                self.__sm_pars.set(sm_name, str(sm_indi),str(sonsList[(sm_indp * 7) + (sm_indi - 1)]))
                sm_crea.addline("->%s. %s" % (str(sm_indi), str(sonsList[(sm_indp * 7) + (sm_indi - 1)])))

                if bool(SoundInfo.sm_stic):
                    sm_crea.submenu(sm_indi, "sm_type_%s_%s" % (str(sonsType), str(sm_indp)))

            if sm_indp + 1 < sm_page:
                sm_crea.addline("8. Next")
                sm_crea.submenu(8, "sm_type_%s_%s" % (str(sonsType), str(sm_indp + 1)))

            if sm_indp == 0:
                if len(typeList) > 1:
                    sm_crea.addline("9. Type")
                    sm_crea.submenu(9, "sm_type_0")

                else:
                    sm_crea.addline("9. Menu")
                    sm_crea.submenu(9, "sm_menu")

            else:
                sm_crea.addline("9. Back")
                sm_crea.submenu(9, "sm_type_%s_%s" % (str(sonsType), str(sm_indp - 1)))


            sm_crea.addline("0. Exit")
            sm_crea.menuselect = play
            sm_indp += 1


    def __team(self, typeList):
        """
            Fonction: créer les pages du menu selon représentant les teams
        """

        sm_team = popuplib.create("sm_team")
        sm_team.addline("Liste des équipes")
        sm_team.addline("->1. Anti-terroristes")
        sm_team.addline("->2. Terroristes")
        sm_team.addline("->3. Spectateurs")
        sm_team.addline("9. Menu")
        sm_team.addline("0. Exit")

        if len(typeList) > 1:
            sm_team.submenu(1, "sm_type_0")
            sm_team.submenu(2, "sm_type_0")
            sm_team.submenu(3, "sm_type_0")

        else:
            sm_team.submenu(1, "sm_type_%s_0" % str(typeList[0]))
            sm_team.submenu(2, "sm_type_%s_0" % str(typeList[0]))
            sm_team.submenu(3, "sm_type_%s_0" % str(typeList[0]))

        sm_team.submenu(9, "sm_menu")
        sm_team.menuselect = team


    def getDown(self):
        """
            Fonction: renvoie une liste de téléchargement
        """

        return self.__sm_down[:]


    def getConf(self):
        """
            Fonction: renvoie la configuration du script
        """

        return self.__sm_conf


    def getMenu(self):
        """
            Fonction: renvoie la configuration du menu
        """

        return self.__sm_pars


class SoundUser:
    """
        Classe privé

            -créer un menu 'indépendant' correspondant aux joueurs présent sur le serveur 
    """

    def __init__(self):
        """
            Fonction: créer les pages du menu selon la liste des joueurs
        """

        self.__sm_conf = ConfigParser.ConfigParser()
        self.__sm_pars = ConfigParser.ConfigParser()


    def suMake(self, userMenu, userList):
        """
            Fonction: créer les pages du menu selon la liste des joueurs
        """

        if int(userMenu):

            if self.__sm_conf.has_section(userMenu):
                self.__sm_conf.remove_section(userMenu)

            self.__sm_conf.add_section(userMenu)

            if self.__sm_pars.has_section(userMenu):
                self.__sm_pars.remove_section(userMenu)

            self.__sm_pars.add_section(userMenu)

            sm_indu = 0
            for sm_user in userList:

                sm_indu += 1
                self.__sm_conf.set(userMenu, str(sm_indu), str(es.getplayername(sm_user)))

            self.__user(userMenu, userList)
            popuplib.send("sm_user_%s_0" % str(userMenu), userMenu)


    def __page(self, itemCount):
        """
            Fonction: déterminer le nombre de pages
        """

        if itemCount < 8:
            return 1

        else:
            sm_page = itemCount / 6
            sm_rest = itemCount % 6

            if sm_rest > 1:
                sm_page += 1

            return sm_page


    def __item(self, itemIndex, itemPages, itemCount):
        """
            Fonction: déterminer le nombre de choix
        """

        if itemIndex + 1 < itemPages:
            return 6

        else:
            return itemCount - ((itemIndex) * 6)


    def __user(self, userMenu, userList):
        """
            Fonction: créer les pages du menu selon la liste des joueurs
        """

        sm_page = self.__page(len(userList))
        sm_indp = 0

        while sm_indp < sm_page:
            sm_indi = 0
            sm_item = self.__item(sm_indp, sm_page, len(userList))
            sm_name = "sm_user_%s_%s" % (str(userMenu), str(sm_indp))

            sm_crea = popuplib.create(sm_name)
            sm_crea.addline("Liste des joueurs :    %s/%s" % (str(sm_indp + 1), str(sm_page)))

            while sm_indi < sm_item:
                sm_indi += 1
                sm_crea.addline("->%s. %s" % (str(sm_indi), str(self.__sm_conf.get(userMenu, str((sm_indp * 6) + sm_indi)))))
                sm_crea.submenu(sm_indi, "sm_user_%s_%s" % (str(userMenu), str(sm_indp)))

            if sm_indp + 1 < sm_page:
                sm_crea.addline("7. Valider")
                self.__sm_pars.set(userMenu, str(sm_indp), str(7))

                if len(SoundInfo.sm_menu.getConf().sections()) > 1:
                    sm_crea.submenu(7, "sm_type_0")

                else:
                    sm_crea.submenu(7, "sm_type_%s_0" % str(SoundInfo.sm_menu.getConf().sections()[0]))

                sm_crea.addline("8. Next")
                sm_crea.submenu(8, "sm_user_%s_%s" % (str(userMenu), str(sm_indp + 1)))

            else:
                sm_crea.addline("8. Valider")
                self.__sm_pars.set(userMenu, str(sm_indp),  str(8))

                if len(SoundInfo.sm_menu.getConf().sections()) > 1:
                    sm_crea.submenu(8, "sm_type_0")

                else:
                    sm_crea.submenu(8, "sm_type_%s_0" % str(SoundInfo.sm_menu.getConf().sections()[0]))

            if sm_indp == 0:
                sm_crea.addline("9. Menu")
                sm_crea.submenu(9, "sm_menu")

            else:
                sm_crea.addline("9. Back")
                sm_crea.submenu(9, "sm_user_%s_%s" % (str(userMenu), str(sm_indp - 1)))


            self.__sm_pars.set(userMenu, str(sm_name), str(sm_indi))
            sm_crea.addline("0. Exit")
            sm_crea.menuselect = user
            sm_indp += 1


    def userConf(self):
        """
            Fonction: obtenir la configuration de la liste des joueurs
        """

        return self.__sm_conf


    def userMenu(self):
        """
            Fonction: obtenir la configuration du menu de l'utilisateur
        """

        return self.__sm_pars


class SoundStop:
    """
        classe privé.

            -créer une liste des sons qui ont été joué
    """

    def __init__(self):
        """
            Fonction: initialisation de la classe
        """

        self.__sm_stop = []

    def setSound(self, addSound):
        """
            Fonction: ajouter un sons a la liste
        """

        self.__sm_stop.append(addSound)

    def getSound(self):
        """
            Fonction: renvoie la liste des sons joué
        """

        return self.__sm_stop

    def delSound(self):
        """
            Fonction: éffacer la liste des sons joué
        """

        self.__sm_stop = []


class SoundInfo:
    """
        Classe privé.

            -encapsuler les variables utile au script
            -initialiser la configuration du script
            -faire télécharger les fichiers 
    """

    sm_menu = SoundMenu()
    sm_user = SoundUser()
    sm_stop = SoundStop()
    sm_down = es.ServerVar("sm_dlfile")
    sm_stic = es.ServerVar("sm_sticky")
    sm_adms = es.ServerVar("sm_admins")
    sm_list = ConfigParser.ConfigParser()


    @staticmethod
    def setConfig():
        """
            Fonction: initialiser la configuration du script
        """

        es.ServerVar(sm_info.name, sm_info.version, "version actuelle du script").makepublic()
        es.ForceServerCommand("es_mexec ../cfg/sound_menu/config.cfg")
        SoundInfo.sm_menu.smMake()

        if bool(SoundInfo.sm_down):
            SoundInfo().download()


    @staticmethod
    def download():
        """
            fonction: ajouter les fichier a la table de téléchargement
        """

        for sm_down in SoundInfo.sm_menu.getDown():
            es.stringtable("downloadables", sm_down)


#    Load    #
def load():
    SoundInfo().setConfig()


#    Config    #
def es_map_start(event_var):
    delpop()
    SoundInfo().setConfig()


def round_end(event_var):
    SoundInfo.sm_stop.delSound()


def player_disconnect(event_var):
    if event_var["networkid"] in str(SoundInfo.sm_adms).split(","):
        if SoundInfo.sm_user.userMenu().has_section(int(event_var["userid"])):
            for sm_dele in SoundInfo.sm_user.userMenu().options(int(event_var["userid"])):
                if popuplib.exists(sm_dele):
                    popuplib.delete(sm_dele)

        if SoundInfo.sm_list.has_section(int(event_var["userid"])):
            SoundInfo.sm_list.remove_section(int(event_var["userid"]))


#    Command    #
def es_client_command(event_var):
    if event_var["command"] == "!sound_menu":
        if es.getplayersteamid(event_var["userid"]) in str(SoundInfo.sm_adms).split(","):
            if popuplib.isqueued(popuplib.active(event_var["userid"])["name"], event_var["userid"]):
                popuplib.unsendname(popuplib.active(event_var["userid"])["name"], event_var["userid"])

            else:
                popuplib.send("sm_menu", event_var["userid"])


#    Menu    #
def menu(userid, choice, popupid):
    if choice < 5:
        if SoundInfo.sm_list.has_section(userid):
            SoundInfo.sm_list.remove_section(userid)

        SoundInfo.sm_list.add_section(userid)

        if choice == 1:
            SoundInfo.sm_list.set(userid, "player", playerlib.getUseridList("#human"))

        elif choice == 2:
            SoundInfo.sm_user.suMake(userid, playerlib.getUseridList("#human"))

        elif choice == 4:
            stop()


def user(userid, choice, popupid):
    if int(SoundInfo.sm_user.userMenu().get(userid, str(popupid))) >= int(choice):
        if SoundInfo.sm_list.has_option(userid, SoundInfo.sm_user.userConf().get(userid, str((int(str(popupid).split("_")[3]) * 6) + int(choice)))):
            SoundInfo.sm_list.remove_option(userid, SoundInfo.sm_user.userConf().get(userid, str((int(str(popupid).split("_")[3]) * 6) + int(choice))))
            popuplib.find(popupid).modline(int(choice + 1), "->%s. %s" % (str(choice), SoundInfo.sm_user.userConf().get(userid, str((int(str(popupid).split("_")[3]) * 6) + int(choice)))))

        else:
            SoundInfo.sm_list.set(userid, SoundInfo.sm_user.userConf().get(userid, str((int(str(popupid).split("_")[3]) * 6) + int(choice))), "player")
            popuplib.find(popupid).modline(int(choice + 1), "->%s. * %s" % (str(choice), SoundInfo.sm_user.userConf().get(userid, str((int(str(popupid).split("_")[3]) * 6) + int(choice)))))

    elif SoundInfo.sm_user.userMenu().get(userid, str(popupid).split("_")[3]) == str(choice):
        sm_list = []

        for sm_user in SoundInfo.sm_list.options(userid):
            sm_list.append(es.getuserid(sm_user))

        SoundInfo.sm_list.remove_section(userid)
        SoundInfo.sm_list.add_section(userid)
        SoundInfo.sm_list.set(userid, "player", sm_list)


def team(userid, choice, popupid):
    if choice == 1:
        SoundInfo.sm_list.set(userid, "player", playerlib.getUseridList("#human,#ct"))

    elif choice == 2:
        SoundInfo.sm_list.set(userid, "player", playerlib.getUseridList("#human,#t"))

    elif choice == 3:
        sm_team = playerlib.getUseridList("#human,#spec")
        for sm_user in playerlib.getUseridList("#human,#un"):
            sm_team.append(sm_user)

        SoundInfo.sm_list.set(userid, "player", sm_team)


def stop():
    for sm_user in playerlib.getUseridList("#human"):
        for sm_stop in SoundInfo.sm_stop.getSound():
            es.stopsound(sm_user, sm_stop)

    SoundInfo.sm_stop.delSound()


def play(userid, choice, popupid):
    if SoundInfo.sm_menu.getMenu().has_option(str(popupid), str(choice)):
        if str(popupid).split("_")[2] in SoundInfo.sm_menu.getConf().sections():
            if SoundInfo.sm_list.has_option(int(userid), "player"):
                for sm_user in SoundInfo.sm_list.get(int(userid), "player"):
                    es.playsound(sm_user, SoundInfo.sm_menu.getConf().get(str(popupid).split("_")[2], SoundInfo.sm_menu.getMenu().get(str(popupid), str(choice))), 1)
                    SoundInfo.sm_stop.setSound(SoundInfo.sm_menu.getConf().get(str(popupid).split("_")[2], SoundInfo.sm_menu.getMenu().get(str(popupid), str(choice))))


#    Unload    #
def unload():
    delpop()


def delpop():
    if popuplib.exists("sm_menu"):
        popuplib.close("sm_menu", playerlib.getUseridList("#human"))
        popuplib.delete("sm_menu")

    for sm_dele in SoundInfo.sm_menu.getMenu().sections():
        if popuplib.exists(sm_dele):
            popuplib.close(sm_dele, playerlib.getUseridList("#human"))
            popuplib.delete(sm_dele)

    for sm_user in SoundInfo.sm_user.userMenu().sections():
        for sm_dele in SoundInfo.sm_user.userMenu().options(sm_user):
            if popuplib.exists(sm_dele):
                popuplib.close(sm_dele, playerlib.getUseridList("#human"))
                popuplib.delete(sm_dele)

#============================================================================================================================================#
